c***** gcfft.f ***** version: 01 Dec 2013 ******************************
c Calculates the complex Fourier transform of gridded 2-D data.
c***********************************************************************
      subroutine gcfft(job,koh)
      implicit none
      include 'constants.inc'
c
c Arguments:
c
      integer job,koh
c
c Common Variables:
c
      complex*16 data(ngmx,ngmx),dwk(nxm)
      integer iwk(nxm)
      common/FFTDAT/data,iwk,dwk
c
      integer ntr
      complex*16 herr(ngmx,ngmx),kerr(ngmx,ngmx)
      complex*16 cgrd(ngmx,ngmx),hgrd(ngmx,ngmx),kgrd(ngmx,ngmx)
      complex*16 kmgd(ngmx,ngmx),tmgd(ngmx,ngmx),twgd(ngmx,ngmx)
      common/MODGRD/cgrd,herr,hgrd,kerr,kgrd,kmgd,tmgd,twgd,ntr
c
c Local Variables:
c
      complex*16 dcmplx,dconjg
      integer i,j,l,m,n1,n2
      real*8 dnm
c
      if(koh.eq.1)then
        do j=1,ntr
          do i=1,ntr
            data(i,j)=hgrd(i,j)
          enddo
        enddo
      elseif(koh.eq.2)then
        do j=1,ntr
          do i=1,ntr
            data(i,j)=kgrd(i,j)
          enddo
        enddo
      elseif(koh.eq.3)then
        do j=1,ntr
          do i=1,ntr
            data(i,j)=herr(i,j)
          enddo
        enddo
      elseif(koh.eq.4)then
        do j=1,ntr
          do i=1,ntr
            data(i,j)=kerr(i,j)
          enddo
        enddo
      elseif(koh.eq.5)then
        do j=1,ntr
          do i=1,ntr
            data(i,j)=cgrd(i,j)
          enddo
        enddo
      elseif(koh.eq.6)then
        do j=1,ntr
          do i=1,ntr
            data(i,j)=tmgd(i,j)
          enddo
        enddo
      elseif(koh.eq.7)then
        do j=1,ntr
          do i=1,ntr
            data(i,j)=kmgd(i,j)
          enddo
        enddo
      elseif(koh.eq.8)then
        do j=1,ntr
          do i=1,ntr
            data(i,j)=twgd(i,j)
          enddo
        enddo
      endif
c
      n1=ntr
      n2=ntr
      dnm=dfloat(n1*n2)
c
      if(job.le.0)then ! Inverse Transform
        do j=1,n2
          do i=1,n1
            data(i,j)=dconjg(data(i,j))
          enddo
        enddo
      endif
c
c Transform second subscript
      do l=1,n1
        do m=1,n2
          dwk(m)=data(l,m)
        enddo
        call fftcc(n2)
        do j=1,n2
          data(l,j)=dwk(j)
        enddo
      enddo
c
c Transform first subscript
      do j=1,n2
        do i=1,n1
          dwk(i)=data(i,j)
        enddo
        call fftcc(n1)
        do i=1,n1
          data(i,j)=dwk(i)
        enddo
      enddo
c
      if(job.le.0)then
        do j=1,n2
          do i=1,n1
            data(i,j)=dconjg(data(i,j))/dnm
          enddo
        enddo
      endif
c
      if(job.eq.1)then
        do j=1,n2
          do i=1,n1
            data(i,j)=data(i,j)/dnm
          enddo
        enddo
      elseif(job.le.0)then
        do j=1,n2
          do i=1,n1
            data(i,j)=data(i,j)*dnm
          enddo
        enddo
      endif
c
      if(koh.eq.1)then
        do j=1,ntr
          do i=1,ntr
            hgrd(i,j)=data(i,j)
          enddo
        enddo
      elseif(koh.eq.2)then
        do j=1,ntr
          do i=1,ntr
            kgrd(i,j)=data(i,j)
          enddo
        enddo
      elseif(koh.eq.3)then
        do j=1,ntr
          do i=1,ntr
            herr(i,j)=data(i,j)
          enddo
        enddo
      elseif(koh.eq.4)then
        do j=1,ntr
          do i=1,ntr
            kerr(i,j)=data(i,j)
          enddo
        enddo
      elseif(koh.eq.5)then
        do j=1,ntr
          do i=1,ntr
            cgrd(i,j)=data(i,j)
          enddo
        enddo
      elseif(koh.eq.6)then
        do j=1,ntr
          do i=1,ntr
            tmgd(i,j)=data(i,j)
          enddo
        enddo
      elseif(koh.eq.7)then
        do j=1,ntr
          do i=1,ntr
            kmgd(i,j)=data(i,j)
          enddo
        enddo
      elseif(koh.eq.8)then
        do j=1,ntr
          do i=1,ntr
            twgd(i,j)=data(i,j)
          enddo
        enddo
      endif
c
      return
      end

