c***** estcvar.for **** version: 13 Jun 2008 ***************************
c  Estimate parameters of the gravity covariogram approximating the
c    observational covariance.
c***********************************************************************
      subroutine estcvar(n0)
      implicit none
      include 'constants.inc'
c
c Arguments:
c
      integer n0
c
c Common Blocks:
c
      integer nc(nrad),nrr
      real*8 cogm(nrad),cogr(nrad),rc(nrad),wtm(nrad),wtr(nrad)
      common/COVARI/cogm,cogr,rc,wtm,wtr,nc,nrr
c
      real*8 aradm,aradr,sillm,sillr,varm0,varr0
      common/COVPAR/aradm,aradr,sillm,sillr,varm0,varr0
c
c Function Variables:
c
      real*8 semv
c
c Local Variables:
c
      integer i,j
      real*8 aha,brdm,brdr,cwt,rd,rsdm,rsdr,vwt,ym,yr
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Covariance model start and stop parameters:
      varm0=0d0
      varr0=0d0
      sillm=0d0
      cwt=0d0
      sillr=0d0
      vwt=0d0
      do i=1,nrr
        if(rc(i).gt.8d5.and.rc(i).lt.1.2d6)then
          sillm=sillm+wtm(i)*cogm(i)
          cwt=cwt+wtm(i)
          sillr=sillr+wtr(i)*cogr(i)
          vwt=vwt+wtr(i)
        endif
      enddo
      sillm=sillm/cwt
      sillr=sillr/vwt
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Solve just once for best-fitting radius parameter of covariogram:
      brdm=1d20
      brdr=1d20
      do j=1,120
        rd=dfloat(j)*1d4
        rsdm=0d0
        rsdr=0d0
        cwt=0d0
        vwt=0d0
c Grid search for radius parameter of spherical model (Gaussian process)
        do i=1,nrr
          if(rc(i).lt.1.2d6)then
            aha=rc(i)/rd
            ym=semv(aha,varm0,sillm)
            yr=semv(aha,varr0,sillr)
            rsdm=rsdm+wtm(i)*(cogm(i)-ym)*(cogm(i)-ym)
            rsdr=rsdr+wtr(i)*(cogr(i)-yr)*(cogr(i)-yr)
            cwt=cwt+wtm(i)
            vwt=vwt+wtr(i)
          endif
        enddo
        if(rsdm/cwt.lt.brdm)then
          brdm=rsdm/cwt
          aradm=rd
        endif
        if(rsdr/vwt.lt.brdr)then
          brdr=rsdr/vwt
          aradr=rd
        endif
      enddo
c
c     open(7,file='Plots/covmod.dat',form='formatted',status='unknown')
      open(7,file='Plots_DLS/covmod.dat',form='formatted',status=
     &    'unknown')
      rewind(7)
      do i=1,nrr
        ym=semv(rc(i)/aradm,varm0,sillm)
        yr=semv(rc(i)/aradr,varr0,sillr)
        write(7,*)rc(i)/1d3,ym,yr
      enddo
      close(7)
c
      if(n0.eq.0)then
c       open(7,file='Plots/covmod0.dat',form='formatted',
        open(7,file='Plots_DLS/covmod0.dat',form='formatted',
     &      status='unknown')
        rewind(7)
        do i=1,nrr
          ym=semv(rc(i)/aradm,varm0,sillm)
          yr=semv(rc(i)/aradr,varr0,sillr)
          write(7,*)rc(i)/1d3,ym,yr
        enddo
        close(7)
      endif
      n0=n0+1
c
      return
      end

