c***** optint.for ***** version: 09 Mar 2017 ***************************
c  Optimally interpolate current estimates of crustal thickness and 
c     Vp/Vs ratios to a specified EARS site.  The expected value and
c     uncertainty estimates can be used subsequently to modify the
c     error function for that site. 
c***********************************************************************
      subroutine optint
      implicit none
      include 'constants.inc'
c
c Common Blocks:
c
      integer n,nl
      real*8 tc_err,tc_exp,vv_err,vv_exp
      common/EXPECT/tc_err,tc_exp,vv_err,vv_exp,n,nl
c
      character*10 site(nsta)
      integer neq(nsta),nmeas
      real*8 el(nsta),cred(nsta)
      real*8 tc(nsta),tce(nsta),vv(nsta),vve(nsta),xl(nsta),yl(nsta)
      common/INDATA/site,el,cred,tc,tce,vv,vve,xl,yl,neq,nmeas
c
      integer inr(mint),nnt
      real*8 rnr(mint)
      common/NEARST/rnr,inr,nnt
c
c Local Variables:
c
      integer i
      real*8 hr,hx,kr,kx
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Sort out nnt nearest points:
      call ignarst(xl(n),yl(n),-1d0,150,n)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Write nearest sites to file for quality check:
      if(site(n)(6:10).eq.'     ')then
        open(unit=13,file='HK_Stacks/'//site(n)(1:5)//'_nrst.sr',
     &      status='unknown')
      elseif(site(n)(7:10).eq.'    ')then
        open(unit=13,file='HK_Stacks/'//site(n)(1:6)//'_nrst.sr',
     &      status='unknown')
      elseif(site(n)(8:10).eq.'   ')then
        open(unit=13,file='HK_Stacks/'//site(n)(1:7)//'_nrst.sr',
     &      status='unknown')
      elseif(site(n)(9:10).eq.'  ')then
        open(unit=13,file='HK_Stacks/'//site(n)(1:8)//'_nrst.sr',
     &      status='unknown')
      elseif(site(n)(10:10).eq.' ')then
        open(unit=13,file='HK_Stacks/'//site(n)(1:9)//'_nrst.sr',
     &      status='unknown')
      else
        open(unit=13,file='HK_Stacks/'//site(n)//'_nrst.sr',
     &      status='unknown')
      endif
      rewind(13)
      do i=1,10
        write(13,'(a10,f7.2)')site(inr(i)),rnr(i)*1d-3
      enddo
      close(13)
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Interpolation, variance estimation at site n:
      call krige(150,hx,hr,kx,kr)
c Keep site expected values and confidence intervals:
      tc_exp=hx
      tc_err=hr
      vv_exp=kx
      vv_err=kr
c
      end

