c***** read_ears.for ***** version: 11 Dec 2013 ************************
c Read in EARS-derived crustal thickness and Vp/Vs estimates and any 
c   useful ancillary information from the EARS funky format.
c***********************************************************************
      subroutine read_ears(iter,inn)
      implicit none
      include 'constants.inc'
c
c Arguments:
c
      integer inn,iter
c
c Common Blocks:
c
      character*10 site(nsta)
      integer neq(nsta),nmeas
      real*8 el(nsta),cred(nsta)
      real*8 tc(nsta),tce(nsta),vv(nsta),vve(nsta),xl(nsta),yl(nsta)
      common/INDATA/site,el,cred,tc,tce,vv,vve,xl,yl,neq,nmeas
c
      real*8 dcy(nsta),dsy(nsta)
      common/STORCS/dcy,dsy
c
c Local Variables:
c
      character line*200,net*4,sit*5,sitt*10
      integer i,j,m1,m2
      real*8 ht,tct,vvt
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Open the EARS master data file:
      open(unit=11,file='EARS.xxx',status='old')
      rewind(11)
c Open files to plot initial EARS Tc, Vp/Vs estimates:
c     open(unit=12,file='Plots/EARS_raw_tc.llze',status='unknown')
      open(unit=12,file='Plots_DLS/EARS_raw_tc.llze',status='unknown')
      rewind(12)
c     open(unit=13,file='Plots/EARS_raw_vr.llze',status='unknown')
      open(unit=13,file='Plots_DLS/EARS_raw_vr.llze',status='unknown')
      rewind(13)
      open(unit=15,file='HK_Stacks/del_list',status='unknown')
      rewind(15)
c
c Read in the data we want to keep:
      nmeas=0
1     read(11,'(a200)',end=2)line
        nmeas=nmeas+1
c Network:
        m2=0
        i=0
        call getwd(line,m1,m2,i)
        read(line(1:m2-1),'(a)')net
c Station ID:
        call getwd(line,m1,m2,i)
        read(line(m1+1:m2-1),'(a)')sit
        if(net(2:4).eq.'   ')then
          write(site(nmeas),'(a1,a1,a5)')net(1:1),'.',sit
        elseif(net(3:4).eq.'  ')then
          write(site(nmeas),'(a2,a1,a5)')net(1:2),'.',sit
        elseif(net(4:4).eq.' ')then
          write(site(nmeas),'(a3,a1,a5)')net(1:3),'.',sit
        else
          write(site(nmeas),'(a4,a1,a5)')net(1:4),'.',sit
        endif
c Latitude:
        call getwd(line,m1,m2,i)
        read(line(m1+1:m2-1),*)yl(nmeas)
        yl(nmeas)=(9d1-yl(nmeas))*dtr
        dcy(nmeas)=dcos(yl(nmeas))
        dsy(nmeas)=dsin(yl(nmeas))
c Longitude:
        call getwd(line,m1,m2,i)
        read(line(m1+1:m2-1),*)xl(nmeas)
        xl(nmeas)=xl(nmeas)*dtr
c Height:
        call getwd(line,m1,m2,i)
        if(line(m2-2:m2-1).eq.' m')then
          read(line(m1+1:m2-3),*)ht
        else
          read(line(m1+1:m2-4),*)ht
          ht=ht*1d3
        endif
        el(nmeas)=ht
c Crustal thickness:
        call getwd(line,m1,m2,i)
        read(line(m1+1:m2-4),*)tc(nmeas)
c Crustal thickness uncertainty:
        call getwd(line,m1,m2,i)
        read(line(m1+1:m2-4),*)tce(nmeas)
        tce(nmeas)=dmax1(tce(nmeas),2d0)
c Vp/Vs ratio:
        call getwd(line,m1,m2,i)
        read(line(m1+1:m2-1),*)vv(nmeas)
c Vp/Vs ratio uncertainty:
        call getwd(line,m1,m2,i)
        read(line(m1+1:m2-1),*)vve(nmeas)
        vve(nmeas)=dmax1(vve(nmeas),2d-2)
c Number of earthquakes:
        call getwd(line,m1,m2,i)
        call getwd(line,m1,m2,i)
        call getwd(line,m1,m2,i)
        call getwd(line,m1,m2,i)
        read(line(m1+1:m2-1),*)neq(nmeas)
c Plot files:
        write(12,'(f7.2,f7.2,2f5.1)')xl(nmeas)/dtr,-yl(nmeas)/dtr+9d1,
     &      tc(nmeas),tce(nmeas)
        write(13,'(f7.2,f7.2,2f6.3)')xl(nmeas)/dtr,-yl(nmeas)/dtr+9d1,
     &      vv(nmeas),vve(nmeas)
c Initialize credibility = 1
        cred(nmeas)=1d0
c Desired data window:
        if(xl(nmeas).lt.-144d0*dtr.or.xl(nmeas).gt.-47d0*dtr.or.
     &      yl(nmeas).gt.(9d1-9d0)*dtr.or.yl(nmeas).lt.(9d1-64d0)*dtr)
     &      then
          write(15,'(a3,a10)')'rm ',site(nmeas)
          nmeas=nmeas-1
          goto1
        endif
c Check whether stackfile is present:
        if(site(nmeas)(6:10).eq.'     ')then
          open(unit=14,file='HK_Stacks/'//site(nmeas)(1:5)//'.xyz',
     &        status='unknown')
        elseif(site(nmeas)(7:10).eq.'    ')then
          open(unit=14,file='HK_Stacks/'//site(nmeas)(1:6)//'.xyz',
     &        status='unknown')
        elseif(site(nmeas)(8:10).eq.'   ')then
          open(unit=14,file='HK_Stacks/'//site(nmeas)(1:7)//'.xyz',
     &        status='unknown')
        elseif(site(nmeas)(9:10).eq.'  ')then
          open(unit=14,file='HK_Stacks/'//site(nmeas)(1:8)//'.xyz',
     &        status='unknown')
        elseif(site(nmeas)(10:10).eq.' ')then
          open(unit=14,file='HK_Stacks/'//site(nmeas)(1:9)//'.xyz',
     &        status='unknown')
        else
          open(unit=14,file='HK_Stacks/'//site(nmeas)//'.xyz',
     &        status='unknown')
        endif
        rewind(14)
        read(14,'(a200)',end=5)line
        if(line(1:6).eq.'<html>')goto5
        close(14)
      goto1
5       close(14)
        nmeas=nmeas-1
c
      goto1
2     close(11)
      close(12)
      close(13)
c
c Initialize with previously updated H-K estimates if specified:
      if(inn.ne.0)then
c       open(11,file='Plots/EARS.upd',status='old')
        open(11,file='Plots_DLS/EARS.upd',status='old')
        rewind(11)
3       read(11,'(a10,f6.2,f7.4)',end=4)sitt,tct,vvt
          do i=1,nmeas
            if(site(i).eq.sitt)then
              tc(i)=tct
              vv(i)=vvt
c Test algorithm: Reduce variation in vP/vS by 10%
              vv(i)=1.79d0+9d-1*(vv(i)-1.79d0)
            endif
          enddo
        goto3
4       close(11)
      endif
c
c Read in fix-valued sites from analyst correction:
      call settl(iter)
c
      return
      end

c***** getwd.for ***** version: 04 Jan 2008 ****************************
c Identify the next word in a line of EARS data from comma delimitors.
c***********************************************************************
      subroutine getwd(line,m1,m2,i)
      implicit none
c
      character line*200
      integer i,m1,m2
      m1=m2
      m2=0
      dowhile(m2.eq.0)
        i=i+1
        if(line(i:i).eq.',')m2=i
      enddo
c
      return
      end

