c***** semgram.for **** version: 31 Mar 2009 ***************************
c  Evaluates the semivariograms of EARS data for crustal thickness and
c    Vp/Vs ratio.
c***********************************************************************
      subroutine semgram(n0)
      implicit none
      include 'constants.inc'
c
c Arguments:
c
      integer n0
c
      character*10 site(nsta)
      integer neq(nsta),nmeas
      real*8 el(nsta),cred(nsta)
      real*8 tc(nsta),tce(nsta),vv(nsta),vve(nsta),xl(nsta),yl(nsta)
      common/INDATA/site,el,cred,tc,tce,vv,vve,xl,yl,neq,nmeas
c
      integer ns(nrad),nr
      real*8 rr(nrad),svtc(nrad),svvv(nrad),wtc(nrad),wtv(nrad)
      common/SEMVAR/svtc,svvv,rr,wtc,wtv,ns,nr
c
      real*8 aradc,aradv,sillc,sillv,varc0,varv0
      common/SMVPAR/aradc,aradv,sillc,sillv,varc0,varv0
c
      real*8 dcy(nsta),dsy(nsta)
      common/STORCS/dcy,dsy
c
c Local Variables:
c
      integer i,j,n1,n2,nrr
      real*8 cbar,ccs,r,varc,varv,vbar
c
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      do i=1,nrad
        svtc(i)=0d0
        wtc(i)=0d0
        svvv(i)=0d0
        wtv(i)=0d0
        rr(i)=0d0
        ns(i)=0
      enddo
c
      do n1=1,nmeas
        do n2=n1+1,nmeas
          ccs=dcy(n2)*dcy(n1)+dsy(n2)*dsy(n1)*dcos(xl(n2)-xl(n1))
          ccs=dmax1(dmin1(ccs,1d0),-1d0)
          r=A*dacos(ccs)
          nrr=idnint(r/del)+1
          if(nrr.le.nrad)then
            varc=1d0/(tce(n1)*tce(n1)+tce(n2)*tce(n2))
            svtc(nrr)=svtc(nrr)+varc*(tc(n1)-tc(n2))**2
            wtc(nrr)=wtc(nrr)+varc
            varv=1d0/(vve(n1)*vve(n1)+vve(n2)*vve(n2))
            svvv(nrr)=svvv(nrr)+varv*(vv(n1)-vv(n2))**2
            wtv(nrr)=wtv(nrr)+varv
            rr(nrr)=rr(nrr)+(varc+varv)*r
            ns(nrr)=ns(nrr)+1
          endif
        enddo
      enddo
c
      i=0
      nr=nrad
      dowhile(i.lt.nr)
        i=i+1
        if(ns(i).lt.5000.and.i.ne.nr)then
          svtc(i)=svtc(i)+svtc(i+1)
          wtc(i)=wtc(i)+wtc(i+1)
          svvv(i)=svvv(i)+svvv(i+1)
          wtv(i)=wtv(i)+wtv(i+1)
          rr(i)=rr(i)+rr(i+1)
          ns(i)=ns(i)+ns(i+1)
          do j=i+1,nr-1
            svtc(j)=svtc(j+1)
            wtc(j)=wtc(j+1)
            svvv(j)=svvv(j+1)
            wtv(j)=wtv(j+1)
            rr(j)=rr(j+1)
            ns(j)=ns(j+1)
          enddo
          nr=nr-1
          i=i-1
        else
          rr(i)=rr(i)/(wtc(i)+wtv(i))
          svtc(i)=svtc(i)/wtc(i)
          svvv(i)=svvv(i)/wtv(i)
        endif
      enddo
c
c     open(10,file='Plots/semvar.dat',status='unknown')
      open(10,file='Plots_DLS/semvar.dat',status='unknown')
      rewind(10)
      do i=1,nr
        write(10,'(f8.3,f5.1,f7.4,i8)')rr(i)/1d3,dsqrt(svtc(i)),
     &      dsqrt(svvv(i)),ns(i)
      enddo
      close(10)
c
      if(n0.eq.0)then
c       open(10,file='Plots/semvar0.dat',status='unknown')
        open(10,file='Plots_DLS/semvar0.dat',status='unknown')
        rewind(10)
        do i=1,nr
          write(10,'(f8.3,f5.1,f7.4,i8)')rr(i)/1d3,dsqrt(svtc(i)),
     &      dsqrt(svvv(i)),ns(i)
        enddo
        close(10)
      endif
c
      return
      end
